﻿Imports System.io

Public Class frmHello

    Dim StorageSequenceList(12) As string
    Dim StockList(100,1) As string
    Dim CurrMoveInPos As string             'Einwärtsbewegung, move in operation
    Dim CurrMoveOutPos As string            'Auswärtsbewegungmove out operation

    Private Sub cmdProgramEnd_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdProgramEnd.Click
        end
    End Sub

    Private Sub cmdManInX_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdManInX.Click
        NewJob_InX
    End Sub

    Private Sub cmdManOutX_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdManOutX.Click
        NewJob_OutX
    End Sub

    Private Sub cmdManInY_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdManInY.Click
        NewJob_InY
    End Sub

    Private Sub cmdManOutY_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdManOutY.Click
        NewJob_OutY
    End Sub

    Private Sub cmdManInZ_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdManInZ.Click
        NewJob_InZ
    End Sub

    Private Sub cmdManOutZ_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdManOutZ.Click
        NewJob_OutZ
    End Sub

    Private Sub cmdManLiftY_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdManLiftY.Click
        NewJob_LiftY
    End Sub

    Private Sub cmdManBeltIn_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdManBeltIn.Click
        NewJob_InwardsBeltTime
    End Sub

    Private Sub cmdManBeltOut_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdManBeltOut.Click
        NewJob_OutwardsBelt
    End Sub

    Private Sub cmdStopOperation_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdStopOperation.Click

        Me.tmrWatchDog.Enabled=false
        Me.cmdStartOperation.Enabled=true
        Me.cmdStopOperation.Enabled=false
        ManButtonsActive

    End Sub

    Private Sub cmdStartOperation_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdStartOperation.Click

        ManButtonsInactive
        Me.tmrWatchDog.Interval=8000
        Me.tmrWatchDog.Enabled=true
        Me.cmdStopOperation.Enabled=True
        Me.cmdStartOperation.Enabled=false
        
    End Sub

    Private Sub cmdCheckIP_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdCheckIP.Click

        Dim Ergebnis As boolean
        'Debug.Print(ComputerIpStrg(Me.cboKanalAuswahl.Text))

        'Verbindungstest zum ausgewählten Computer
        'Ping selected Computer
        Ergebnis=PingComputer(ComputerIpStrg(Me.cboKanalAuswahl.Text))

        If Ergebnis=True then
            Me.lblKanal.Text=Me.cboKanalAuswahl.Text & "  -  as active computer"
            Me.lblKanal.ForeColor=Color.Black
            IpAndresseZuGlobInt
            'gibt Schaltfläche frei für RoboTXT Zugriff
            'enable buttons for RoboTXT operation
            ManButtonsActive
            AutoButtonsActive
        Else
            Me.lblKanal.Text="no active computer selected"
            Me.lblKanal.ForeColor=Color.Red
            'sperrt Schaltfläche für RoboTXT Zugriff
            'disable buttons for RoboTXT operation
            ManButtonsInactive
            AutoButtonsInactive
        End If

    End Sub

    Private Sub cmdBarCodeRetry_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdBarCodeRetry.Click

        NewJob_ReadBarCode
        
    End Sub

    Private Sub cmdGetCameraImage_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdGetCameraImage.Click
                            
        'löschen der Bildanzeigefenster und des bar code Leseergebnisses
        'clear picture frames and bar code result
        Me.pbxCameraImageMod.Image=nothing
        Me.pbxCameraImage.Image=nothing
        Me.txtBarCodeResult.Text=""

        'neuer Vorgang: Bilder von RoboTXT auf Festplatte schreiben
        'new job: get picture from RoboTXT
        globJobSequenceNo=globJobSequenceNo+1
        globJobErrorRetry=0 'for JobFinisher
        Me.dgvJobList.Rows.Add(globJobSequenceNo,5,"waiting","get picture from RoboTXT",1000,now)

        'neuer Vorgang: Bilder Laden in PictureBox
        'new job: show new picture
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,4,"waiting","show new picture",5000,now)

        'neuer Vorgang: Bilder löschen von Festplatte
        'new job: delete all RoboTXT pictures on system
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,3,"waiting","delete all RoboTXT pictures on system",3000,now)

        'neuer Vorgang: analysiere Strich Code
        'new job: analyse bar code
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,7,"waiting","analyse bar code from camera image",3000,now)

        'neuer Vorgang: Pause
        'new job: pause
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,1,"waiting","pause",1000,now)

        'wartende Systemprozesse abarbeiten
        'process pending events
        System.Windows.Forms.Application.DoEvents()

        'dispatcher wieder aktivieren
        'restart dispatcher
        Me.tmrJobDispatcher.Enabled=true
    
    End Sub

    Private Sub Form1_Load( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles MyBase.Load
        
        'Fenster Einstellung maximal
        'maximize application window
        'Me.WindowState = FormWindowState.Maximized

        'Fensterüberschrift
        'new text in application window header
        Me.Text = "RoboTXT warehousing " & Application.ProductVersion & " [freeware for non commercial use] " & Application.CompanyName

        'Startdefinition von Variablen
        'variable start definition
        globJobSequenceNo =0
        globJobActionID =0

        'Festlegung der Einlagerungsreihenfolge
        'define Storage Sequence List
        StorageSequenceList(0)="12"     'Anzahl an Elementen in dieser indizierten Variablen, number of items in the array
        StorageSequenceList(1)="A1"
        StorageSequenceList(2)="A2"
        StorageSequenceList(3)="B1"
        StorageSequenceList(4)="A3"
        StorageSequenceList(5)="B2"
        StorageSequenceList(6)="C1"
        StorageSequenceList(7)="A4"
        StorageSequenceList(8)="B3"
        StorageSequenceList(9)="C2"
        StorageSequenceList(10)="B4"
        StorageSequenceList(11)="C3"
        StorageSequenceList(12)="C4"

        'exteren Datei "StockList.txt" auslesen und die Daten in einer indizierten Variablen speichern (code und Warenbezeichnung)
        'Read "StockList.txt" from external file and store data in array(code and trade description)
        FillStockList
                
    End Sub

    Private Function NextFreePos()

        Dim m As Integer
        Dim n As Integer
        Dim ItemInList As boolean

        NextFreePos="00"

        if Me.dgvInventory.RowCount=0 then
            NextFreePos="A1"
        else
            For m=1 to Val(StorageSequenceList(0))
                ItemInList=false
                For n=0 to Me.dgvInventory.RowCount-1
                    If Me.dgvInventory.rows(n).Cells(2).value=StorageSequenceList(m) then
                        ItemInList=true
                    End If
                Next
                If ItemInList=false then
                    NextFreePos=StorageSequenceList(m)
                    Exit function
                End If
            Next
        End If

    End Function

    Private Sub FillStockList()

        'Daten aus externer Datei lesen und Tabelle ausfüllen
        'read data from external file an fill out table
        Dim StockListRecordData As String
        Dim n As Integer

        n = 1

        Try
            Using sr As New System.IO.StreamReader(Application.StartupPath & "\StockList.txt")
                Do
                    StockListRecordData = sr.ReadLine()
                    If StockListRecordData <>"" Then
                        StockList(n,0)=Strings.Left(StockListRecordData,4)
                        StockList(n,1)=Strings.Right(StockListRecordData,Strings.Len(StockListRecordData)-5)
                        StockList(0,0)=n
                        'Debug.Print (StockListRecordData)
                        'Debug.Print (StockList(n,0))
                        'Debug.Print (StockList(n,1))
                        n = n + 1
                    End If
                Loop Until StockListRecordData Is Nothing
            End Using
        Catch ex As Exception
            'hier eventuelle Fehlerbehandlung, ex.Message=Fehlercode
            'error operation to be placed her
        End Try

    End Sub

    Private Function StockListItem(BarCode) As string

        Dim n As Integer

        StockListItem="unknown item"
        
        For n=1 to StockList(0,0)
            If Val(BarCode) = Val(StockList(n,0)) then
                StockListItem=StockList(n,1)
            End If
        Next

    End Function
    
    Private Function ShowRoboPicture(Dateiname As string) As boolean
        
        Dim fs As filestream

        ShowRoboPicture=false
        on Error GoTo ErrMarke
        
        'die komlizierte Bildanzeige auf Form1 ist erforderlich, weil bei einer anderen Methode die Bilddatei
        'gesperrt ist, wenn das Bild geladen wurde, das darf aber im vorliegenden Fall nicht passieren,
        'weil das nächste Bild mit selbem Dateinamen vom RoboTXT kommt und geschrieben werden soll
        'this complicated way to display the picture on Form1 is necessary because with another methode the picture file
        'is locked after loading the picture to the picture box, but this should not happen because the next
        'picture from RoboTXT is comming with the same file name, this operation sould not disturbed
        fs = New FileStream (Application.StartupPath & "\" & Dateiname, filemode.Open, FileAccess.Read)
        Me.pbxCameraImage.Image=System.Drawing.Image.FromStream(fs)
        fs.Close

        'Debug.Print("OK")
        ShowRoboPicture=true
        Exit function

        ErrMarke: 
            'Es kommt häufiger vor, dass die bereitgestellten Bilder fehlerhaft sind
            'quite frequently the provided pictures contain errors 
            on Error Resume next            
            ShowRoboPicture=false
            'Debug.Print("Fehler")
            fs.Close
            
    End Function

    Private Function PingComputer(ComputerIP As string) As boolean
        
        on Error goto err

        PingComputer = false
        If My.Computer.Network.Ping(ComputerIP) Then
            PingComputer = True
        End If

        Exit Function

        err:
            PingComputer = false

    End Function

    Private Function ComputerIpStrg (Kanal As string) As string

        Dim x As Integer

        x=Strings.InStr(Kanal,"  -  ")
        If x = 0 then
            ComputerIpStrg="error"
        else
            ComputerIpStrg=Strings.Left(Kanal, Strings.Len(Kanal)-x+4)
        End If

        'Debug.Print(Kanal)

    End Function

    Private Sub IpAndresseZuGlobInt

        Dim x1 As Integer
        Dim x2 As Integer
        Dim x3 As Integer

        x1=Strings.InStr(1,Me.lblKanal.text,".")
        x2=Strings.InStr(x1+1,Me.lblKanal.text,".")
        x3=Strings.InStr(x2+1,Me.lblKanal.text,".")
        x4=Strings.InStr(x3+1,Me.lblKanal.text,"  -  ")

        globIntIpAndresseA=Val(Strings.left(Me.lblKanal.text,x1))
        globIntIpAndresseB=Val(Strings.Mid(Me.lblKanal.text,x1+1,x2-x1))
        globIntIpAndresseC=Val(Strings.Mid(Me.lblKanal.text,x2+1,x3-x2))
        globIntIpAndresseD=Val(Strings.Mid(Me.lblKanal.text,x3+1,x4-x3))

        'Debug.Print(globIntIpAndresseA)
        'Debug.Print(globIntIpAndresseB)
        'Debug.Print(globIntIpAndresseC)
        'Debug.Print(globIntIpAndresseD)

    End Sub

    Sub ManButtonsActive
        Me.cmdGetCameraImage.Enabled=true
        Me.cmdManBeltIn.Enabled=true
        Me.cmdManBeltOut.Enabled=true
        Me.cmdManInX.Enabled=true
        Me.cmdManInY.Enabled=true
        Me.cmdManInZ.Enabled=true
        Me.cmdManLiftY.Enabled=true
        Me.cmdManOutX.Enabled=true
        Me.cmdManOutY.Enabled=true
        Me.cmdManOutZ.Enabled=true
        Me.cmdBarCodeRetry.Enabled=true
    End Sub

    Sub ManButtonsInactive
        Me.cmdGetCameraImage.Enabled=false
        Me.cmdManBeltIn.Enabled=false
        Me.cmdManBeltOut.Enabled=false
        Me.cmdManInX.Enabled=false
        Me.cmdManInY.Enabled=false
        Me.cmdManInZ.Enabled=false
        Me.cmdManLiftY.Enabled=false
        Me.cmdManOutX.Enabled=false
        Me.cmdManOutY.Enabled=false
        Me.cmdManOutZ.Enabled=false
        Me.cmdBarCodeRetry.Enabled=false
    End Sub

    Sub AutoButtonsActive
        Me.cmdStartOperation.Enabled=true
    End Sub

    Sub AutoButtonsInactive
        Me.cmdStartOperation.Enabled=false
    End Sub

    Private Function ReadBarCode()

        on Error Resume next

        Dim ImageHeight As Integer
        Dim ImageWidth As integer
        Dim h As Integer
        Dim v As integer
        Dim m As Integer                            'mehrfach als Zähler verwendet, multible used counter
        Dim n As Integer                            'mehrfach als Zähler verwendet, multible used counter
        Dim PixelColor As System.Drawing.Color
        Dim ColorAveage As integer
        Dim ColorRed As Integer
        Dim ColorGreen As Integer
        Dim ColorBlue As integer
        Dim PatternData(330,25) as Integer
        Dim ArrayPointer As integer
        Dim ChangeCounter As Integer
        Dim ConstantColorCounter as integer
        Dim PixelColorOld As System.Drawing.color
        Dim PixelColorNow As System.Drawing.color
        Dim PixelCount As integer 
        Dim BarWidth As single                      'einfache Gleitkommazahl, floating point number
        Dim BarNew As integer
        Dim BarCodeCollection As string
        Dim BarCodePart1 As string
        Dim BarCodePart2 As string
        Dim BarCodePart3 As string
        Dim BarCodePart4 As string
        Dim BarCodeResult(25) As integer

        'Schritt 1: Bild kopieren in pbxCameraImageMod, allerdings als Bitmap
        '           Hierbei wird eine Konvertierung aus jpg nach bmp vorgenommen
        'Step    1: copy picture to pbxCameraImageMod, as Bitmap
        '           jpg is automatically converted to bmp format
        PicBitmap = new Bitmap(Me.pbxCameraImage.Image)
        Me.pbxCameraImageMod.Image=PicBitmap

        'Schritt 2: Anzahl Bildpunkte analysieren, horizontal und vertikal
        'Step    2: count number of pixels, horizontal und vertical
        ImageHeight=Me.pbxCameraImage.Image.Height
        ImageWidth=Me.pbxCameraImage.Image.Width
        'Debug.Print ("ImageHeight=" & ImageHeight & "  ImageWidth=" & ImageWidth)

        'Schritt 3: Bildpunktumformung auf schwarz-weiss gemäß eingestelltem Schwellenwert
        'Step    3: picture transform to black and white in respect to the actual setting of "Camera Im age Modification
        '           Level for Encoding"
        For h=0 to ImageHeight-1        'horizontal durchzählen, count horizontal
            For v=0 to ImageWidth-1     'vertikal durchzählen, count vertical
                'Pixelfarbe analysieren
                'analyse color of pixel
                PixelColor=PicBitmap.GetPixel(v,h)
                ColorRed = PixelColor.R 
                ColorGreen = PixelColor.G
                ColorBlue = PixelColor.B
                'Helligkeitsmittelwert aus den 3 Farben berechnen
                'calculate brightness average value by using 3 colors
                ColorAveage=(ColorRed + ColorGreen + ColorBlue)/3
                'Debug.Print (ColorAveage)
                If ColorAveage < Me.trbLevelBW.Value then
                    'Punkt schwarz einfärben
                    'make pixel black
                    PicBitmap.SetPixel(v,h,Color.Black)
                else
                    'Punkt weiss einfärben
                    'make pixel white
                    PicBitmap.SetPixel(v,h,Color.White)
                End If
                'Debug.Print(PixelColor.R & " " & PixelColor.G & " " & PixelColor.B)
            Next
        Next

        'Schritt 4: Streifenmuster erfassen horizontal und vertikal und Speicherung in array PatternData(x,y)
        'Step    4: analyse bar pattern horizontal und vertical and store it in array PatternData(x,y)
        ArrayPointer=1
        'Einlesen vertikale Streifen
        'read verticale bar pattern
        For v=10 to ImageWidth-1 Step 30
            ChangeCounter=0
            ConstantColorCounter=0
            For h=0 to ImageHeight-1
                If h=0 then
                    PixelColorOld=PicBitmap.GetPixel(v,h)
                else
                    PixelColorNow=PicBitmap.GetPixel(v,h)
                    If PixelColorOld=PixelColorNow then
                        ConstantColorCounter=ConstantColorCounter+1
                    Else
                        PatternData(ChangeCounter,ArrayPointer)=ConstantColorCounter
                        PatternData(0,ArrayPointer)=ChangeCounter
                        'Debug.Print ("ChangeCounter=" & ChangeCounter & " ArrayPointer=" & ArrayPointer & " ConstantColorCounter=" & ConstantColorCounter)
                        ConstantColorCounter=0
                        ChangeCounter=ChangeCounter+1
                        PixelColorOld=PixelColorNow
                    End if
                End If
                'PicBitmap.SetPixel(v,h,Color.Red)
            Next
            PatternData(0,0)=ArrayPointer
            ArrayPointer=ArrayPointer+1
        Next
        'Einlesen horizontale Streifen
        'read horizontal bar pattern
        For h=7 to ImageHeight-1 Step 28
            ChangeCounter=0
            ConstantColorCounter=0
            For v=0 to ImageWidth-1
                If v=0 then
                    PixelColorOld=PicBitmap.GetPixel(v,h)
                else
                    PixelColorNow=PicBitmap.GetPixel(v,h)
                    If PixelColorOld=PixelColorNow then
                        ConstantColorCounter=ConstantColorCounter+1
                    Else
                        PatternData(ChangeCounter,ArrayPointer)=ConstantColorCounter
                        PatternData(0,ArrayPointer)=ChangeCounter
                        'Debug.Print ("ChangeCounter=" & ChangeCounter & " ArrayPointer=" & ArrayPointer & " ConstantColorCounter=" & ConstantColorCounter)
                        ConstantColorCounter=0
                        ChangeCounter=ChangeCounter+1
                        PixelColorOld=PixelColorNow
                    End if
                End If
                'PicBitmap.SetPixel(v,h,Color.Green)
            Next
            PatternData(0,0)=ArrayPointer
            ArrayPointer=ArrayPointer+1
        Next
        'Debug.Print("ArrayPointer=" & ArrayPointer)

        'Schritt 5: array PatternData(x,y) der Farbänderungen aller ausgelesenen Streifen untersuchen
        'STEP    5: read and analyse array PatternData(x,y) with all bar patterns
        BarCodeResult(0)=0
        For m=1 to PatternData(0,0)
            'Debug.Print("m=" & m & " PatternData(0,m)=" & PatternData(0,m))
            PixelCount=0
            BarCodeCollection=""
            For n=1 to PatternData(0,m) 'Diese Schleife enthält alle verwertbaren Daten, loop with usable data
                'Debug.Print ("n=" & n & " m=" & m & " PatternData=" & PatternData(n,m))
                'Berechnung der Gesamtbarcodebreite
                'calculate bar code width
                PixelCount=PixelCount+PatternData(n,m)
                BarWidth=Int((PixelCount/51)+0.5)
            next
            If BarWidth=0 then BarWidth=1
            For n=1 to PatternData(0,m) 'Diese Schleife enthält alle verwertbaren Daten, loop with usable data
                BarNew=Int(PatternData(n,m)/BarWidth)
                If BarNew=3 then BarNew=2
                If BarNew=0 then BarNew=1
                BarCodeCollection=BarCodeCollection & "" & BarNew
            next
            'Debug.Print("PixelCount=" & PixelCount)
            'Debug.Print("BarWidth=" & BarWidth)
            'Debug.Print("BarCodeCollection=" & BarCodeCollection)
            BarCodePart1=resultEncoder(Strings.mid(BarCodeCollection,1,9))
            BarCodePart2=resultEncoder(Strings.mid(BarCodeCollection,11,9))
            BarCodePart3=resultEncoder(Strings.mid(BarCodeCollection,21,9))
            BarCodePart4=resultEncoder(Strings.mid(BarCodeCollection,31,9))
            'Debug.Print("BarCodePart1=" & BarCodePart1)
            'Debug.Print("BarCodePart2=" & BarCodePart2)
            'Debug.Print("BarCodePart3=" & BarCodePart3)
            'Debug.Print("BarCodePart4=" & BarCodePart4)

            If BarCodePart1<>"error" and BarCodePart2<>"error" and BarCodePart3<>"error" and BarCodePart4<>"error" then
                'Debug.Print(Strings.left(BarCodePart1,1))
                if Strings.left(BarCodePart1,1)="R" then 
                    'Strich Code wurde in Vorwärtsrichtung eingelesen
                    'Code was read in forward direction
                    'Debug.Print("reverse")
                    BarCodeResult(0)=BarCodeResult(0)+1
                    BarCodeResult(BarCodeResult(0))=strings.Right(BarCodePart4,1) & strings.Right(BarCodePart3,1) & strings.Right(BarCodePart2,1) & strings.Right(BarCodePart1,1)
                Else
                    'Strich Code wurde in Rückwärtsrichtung eingelesen
                    'Code was read in reverse direction
                    'Debug.Print("forward")
                    BarCodeResult(0)=BarCodeResult(0)+1
                    BarCodeResult(BarCodeResult(0))=strings.Right(BarCodePart1,1) & strings.Right(BarCodePart2,1) & strings.Right(BarCodePart3,1) & strings.Right(BarCodePart4,1)
                End If
                'Debug.Print("BarCodeResult(" & BarCodeResult(0) & ")=" & BarCodeResult(BarCodeResult(0)))
            End If
            
        next

        'Schritt 6: Ergebnisse aus BarCodeResult(x) auswerten
        'Step    6: evaluate resultes in BarCodeResult(x) 
        ReadBarCode="no bar code detected"
        If BarCodeResult(0)=0 then 
            ReadBarCode="no bar code detected"
        End If
        If BarCodeResult(0)=1 then 
            ReadBarCode=BarCodeResult(1)
        End If
        If BarCodeResult(0)=2 then 
            If BarCodeResult(1)=BarCodeResult(2)
                ReadBarCode=BarCodeResult(1)
            else
                ReadBarCode="bar code with errors detected"
            End if
        End If
        If BarCodeResult(0)=3 then 
            If BarCodeResult(1)=BarCodeResult(2) and BarCodeResult(1)=BarCodeResult(3) then
                ReadBarCode=BarCodeResult(1)
            else
                ReadBarCode="bar code with errors detected"
            End if
        End If
        If BarCodeResult(0)=4 then 
            If BarCodeResult(1)=BarCodeResult(2) and BarCodeResult(1)=BarCodeResult(3) and BarCodeResult(1)=BarCodeResult(4) then
                ReadBarCode=BarCodeResult(1)
            else
                ReadBarCode="bar code with errors detected"
            End if
        End If
        If BarCodeResult(0)=5 then 
            If BarCodeResult(1)=BarCodeResult(2) and BarCodeResult(1)=BarCodeResult(3) and BarCodeResult(1)=BarCodeResult(4)  and BarCodeResult(1)=BarCodeResult(5) then
                ReadBarCode=BarCodeResult(1)
            else
                ReadBarCode="bar code with errors detected"
            End if
        End If
        If BarCodeResult(0)=6 then 
            If BarCodeResult(1)=BarCodeResult(2) and BarCodeResult(1)=BarCodeResult(3) and BarCodeResult(1)=BarCodeResult(4)  and BarCodeResult(1)=BarCodeResult(5)   and BarCodeResult(1)=BarCodeResult(6) then
                ReadBarCode=BarCodeResult(1)
            else
                ReadBarCode="bar code with errors detected"
            End if
        End If
        If BarCodeResult(0)=7 then 
            If BarCodeResult(1)=BarCodeResult(2) and BarCodeResult(1)=BarCodeResult(3) and BarCodeResult(1)=BarCodeResult(4)  and BarCodeResult(1)=BarCodeResult(5)   and BarCodeResult(1)=BarCodeResult(6)   and BarCodeResult(1)=BarCodeResult(7) then
                ReadBarCode=BarCodeResult(1)
            else
                ReadBarCode="bar code with errors detected"
            End if
        End If
        If BarCodeResult(0)=8 then 
            If BarCodeResult(1)=BarCodeResult(2) and BarCodeResult(1)=BarCodeResult(3) and BarCodeResult(1)=BarCodeResult(4)  and BarCodeResult(1)=BarCodeResult(5)   and BarCodeResult(1)=BarCodeResult(6)   and BarCodeResult(1)=BarCodeResult(7)   and BarCodeResult(1)=BarCodeResult(8) then
                ReadBarCode=BarCodeResult(1)
            else
                ReadBarCode="bar code with errors detected"
            End if
        End If
        If BarCodeResult(0)=9 then 
            If BarCodeResult(1)=BarCodeResult(2) and BarCodeResult(1)=BarCodeResult(3) and BarCodeResult(1)=BarCodeResult(4)  and BarCodeResult(1)=BarCodeResult(5)   and BarCodeResult(1)=BarCodeResult(6)   and BarCodeResult(1)=BarCodeResult(7)   and BarCodeResult(1)=BarCodeResult(8)   and BarCodeResult(1)=BarCodeResult(9) then
                ReadBarCode=BarCodeResult(1)
            else
                ReadBarCode="bar code with errors detected"
            End if
        End If
        If BarCodeResult(0)=10 then 
            If BarCodeResult(1)=BarCodeResult(2) and BarCodeResult(1)=BarCodeResult(3) and BarCodeResult(1)=BarCodeResult(4)  and BarCodeResult(1)=BarCodeResult(5)   and BarCodeResult(1)=BarCodeResult(6)   and BarCodeResult(1)=BarCodeResult(7)   and BarCodeResult(1)=BarCodeResult(8)   and BarCodeResult(1)=BarCodeResult(10) then
                ReadBarCode=BarCodeResult(1)
            else
                ReadBarCode="bar code with errors detected"
            End if
        End If
        If BarCodeResult(0)=11 then 
            If BarCodeResult(1)=BarCodeResult(2) and BarCodeResult(1)=BarCodeResult(3) and BarCodeResult(1)=BarCodeResult(4)  and BarCodeResult(1)=BarCodeResult(5)   and BarCodeResult(1)=BarCodeResult(6)   and BarCodeResult(1)=BarCodeResult(7)   and BarCodeResult(1)=BarCodeResult(8)   and BarCodeResult(1)=BarCodeResult(10)  and BarCodeResult(1)=BarCodeResult(11) then
                ReadBarCode=BarCodeResult(1)
            else
                ReadBarCode="bar code with errors detected"
            End if
        End If
        
    End Function
    
    Private Sub trbLevelBW_Scroll( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles trbLevelBW.Scroll
        
        Me.txtLevelBW.Text=Me.trbLevelBW.Value

    End Sub

    Private Sub dgvInventory_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles dgvInventory.DoubleClick

        Dim Re As integer
        Dim MsgText As String

        If Me.dgvInventory.Rows.Count=0 then Exit sub

        'Bediener Hinweis vorbereiten
        'prepare message box
        MsgText="Do you want to move out the following article:"
        MsgText=MsgText & ControlChars.CrLf & ControlChars.CrLf
        MsgText=MsgText & Me.dgvInventory.Rows(Me.dgvInventory.SelectedCells.Item(0).RowIndex).Cells(0).value & ControlChars.CrLf
        MsgText=MsgText & Me.dgvInventory.Rows(Me.dgvInventory.SelectedCells.Item(0).RowIndex).Cells(1).value & ControlChars.CrLf
        MsgText=MsgText & Me.dgvInventory.Rows(Me.dgvInventory.SelectedCells.Item(0).RowIndex).Cells(3).value & ControlChars.CrLf
        
        CurrMoveOutPos =  Me.dgvInventory.Rows(Me.dgvInventory.SelectedCells.Item(0).RowIndex).Cells(2).value
        'Debug.Print (CurrMoveOutPos)

        Re=MsgBox( MsgText,MsgBoxStyle.OkCancel+MsgBoxStyle.Exclamation,"move out a stored article from the warehouse")

        If Re=1 then
            'Automatik Betrieb beeenden
            'stop automatic operation
            Me.tmrWatchDog.Enabled=false
            Me.cmdStartOperation.Enabled=true
            Me.cmdStopOperation.Enabled=false
            ManButtonsActive
            'ausgewählten Artikel aus der Warenbestandsliste entfernen
            'remove selected article from JobList
            
            Me.dgvInventory.Rows(Me.dgvInventory.SelectedCells.Item(0).RowIndex).Selected=true
            Me.dgvInventory.Rows.remove(Me.dgvInventory.SelectedRows(Me.dgvInventory.SelectedCells.Item(0).RowIndex))
            'neue jobs erzeugen
            'create new jobs
            NewJob_OutY
            NewJob_PathOut
        End If

    End Sub

    Function resultEncoder(ByVal InputCode As String) As String

        '**********************************************************************************************
        '*** decodieren der Ergebniszeichenkette, wenn möglich
        '**********************************************************************************************
        '*** encoding the result sting, if possible
        '**********************************************************************************************

        resultEncoder = "error"

        'Bar Codes in Vorwärtsrichtung
        'bar codes in forward direction

        If InputCode = "111221211"  Then
            resultEncoder = "F0"
        End If
        If InputCode = "211211112"  Then
            resultEncoder = "F1"
        End If
        If InputCode = "112211112"  Then
            resultEncoder = "F2"
        End If
        If InputCode = "212211111"  Then
            resultEncoder = "F3"
        End If
        If InputCode = "111221112"  Then
            resultEncoder = "F4"
        End If
        If InputCode = "211221111"  Then
            resultEncoder = "F5"
        End If
        If InputCode = "112221111"  Then
            resultEncoder = "F6"
        End If
        If InputCode = "111211212"  Then
            resultEncoder = "F7"
        End If
        If InputCode = "211211211"  Then
            resultEncoder = "F8"
        End If
        If InputCode = "112211211"  Then
            resultEncoder = "F9"
        End If

        'Bar Codes in Rückwärtsrichtung
        'bar codes in reerse direction

        If  InputCode = "112122111" Then
            resultEncoder = "R0"
        End If
        If  InputCode = "211112112" Then
            resultEncoder = "R1"
        End If
        If  InputCode = "211112211" Then
            resultEncoder = "R2"
        End If
        If  InputCode = "111112212" Then
            resultEncoder = "R3"
        End If
        If  InputCode = "211122111" Then
            resultEncoder = "R4"
        End If
        If  InputCode = "111122112" Then
            resultEncoder = "R5"
        End If
        If  InputCode = "111122211" Then
            resultEncoder = "R6"
        End If
        If  InputCode = "212112111" Then
            resultEncoder = "R7"
        End If
        If  InputCode = "112112112" Then
            resultEncoder = "R8"
        End If
        If  InputCode = "112112211" Then
            resultEncoder = "R9"
        End If

    End Function

    Private Sub tmrWatchDog_Tick( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles tmrWatchDog.Tick

        If Me.dgvInventory.RowCount<12 then
            Me.lblFullInfo.Visible=false 
            NewJob_CheckBeltPos1
        else
            Me.lblFullInfo.Visible=true   'Warenhaus voll, warehouse full
        End If

    End Sub

    Private Sub tmrJobDispatcher_Tick( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles tmrJobDispatcher.Tick

        If Me.dgvJobList.RowCount>0 then
            'dispatcher anhalten
            'stop dispatcher
            Me.tmrJobDispatcher.Enabled=false
            'schreibe in erste Reihe
            'write first row
            Me.dgvJobList.rows(0).Cells(2).value="processing"
            'lese erste Reihen
            'read first row
            globJobActionID=Me.dgvJobList.rows(0).Cells(1).value
            'stelle Pausenzeit ein
            'set delay time
            Me.tmrJobWorker.Interval=Me.dgvJobList.rows(0).Cells(4).value
            'aktiviere job worker
            'start job worker
            Me.tmrJobWorker.Enabled=true
        End If

    End Sub

    Private Sub tmrJobFinisher_Tick( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles tmrJobFinisher.Tick
        
        If globJobActionID=5 then

            Dim myDir As New DirectoryInfo(Application.StartupPath)
            Dim myFiles() As FileInfo 
            Dim x As integer

            'Suchen nach neuen gespeicherten Bilddateien, die vom RoboTXT erwartet werden
            'search for new stored pictures, which are expectet to come from RoboTXT
            myFiles = myDir.GetFiles("RoboTxtPic_*.jpg")
            If myFiles.Count=0 then
                'Aufgabe ist nicht erledigt, bislang sind keine Bilder angekommen
                'job is not done, no picture files detected
                globJobErrorWait=globJobErrorWait+1
                'Schreibe Information in erste Reihe der job list
                'write first row in JobList
                Me.dgvJobList.rows(0).Cells(2).value="error, retry " & globJobErrorRetry & "." & globJobErrorWait
                If globJobErrorWait>5 then
                    globJobErrorRetry=globJobErrorRetry+1
                    globJobErrorWait=0
                    Me.tmrJobFinisher.Enabled=false
                    Me.tmrJobWorker.Enabled=true
                End If
                If globJobErrorRetry>5 then
                    'keine weiteren Versuche
                    'stop retry
                    globJobActionID=0
                    globJobErrorRetry=0
                    Me.tmrJobFinisher.Enabled=false
                    'Fehlermedung ausgeben
                    'fire error message
                    x=msgbox("No access to camera data, check connection or restart RoboTXT and retry.",vbOKOnly+vbCritical,"Robo TXT Error")
                    'weil Kamera Bild fehlt (enthält bar code) alle artenden Aufgasbe löschen
                    'delete all waiting jobs, because missing picture which is expected to contain the bar code
                    Me.dgvJobList.rows.Clear
                End If
            else
                'Aufgabe ist nicht erledigt, beende JobFinisher und entferne letzte Aufgabe aus JobList
                'job is done, stop JobFinisher and remove job from JobList
                globJobActionID=0
                Me.tmrJobFinisher.Enabled=false
                Me.dgvJobList.Rows(0).Selected=true
                Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
                System.Windows.Forms.Application.DoEvents()

                'dispatcher wieder aktivieren
                'restart dispatcher
                Me.tmrJobDispatcher.Enabled=true
            End if


        End if 'globJobActionID=5

        
    End Sub

    Private Sub tmrJobWorker_Tick( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles tmrJobWorker.Tick

        Dim Ergebnis As Object  'variant=object

        '*******************************************************************************************************
        '** Pause
        '*******************************************************************************************************
        '** pause
        '*******************************************************************************************************
        If globJobActionID=1 then

            Me.tmrJobWorker.Enabled=false  
            globJobActionID=0
            
            'Debug.Print("globJobActionID=1 abgeschlosen")

            'Aufgabe ist erledigt, diese aus JobList entfernen
            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'dispatcher wieder aktivieren
            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true

        End If



        '*******************************************************************************************************
        '** alle Bilder von Festplatte löschen ("RoboTxtPic_*.jpg")
        '*******************************************************************************************************
        '** delete all pictures from hard disk ("RoboTxtPic_*.jpg")
        '*******************************************************************************************************
        If globJobActionID=3 then
            
            Dim myDir As New DirectoryInfo(Application.StartupPath)
            Dim myFiles() As FileInfo 
            Dim DateinameBild As string

            Me.tmrJobWorker.Enabled=false
            globJobActionID=0

            'Durchzählen der vorhandenen Bilder und alle löschen
            'count through existing picture and delete them
            myFiles = myDir.GetFiles("RoboTxtPic_*.jpg")
            For n As integer = 0 to myFiles.Length-1
                DateinameBild = myFiles(n).name
                'Debug.Print ("löschen: " & DateinameBild)
                myFiles(n).Delete
            Next

            'Debug.Print("globJobActionID=3 abgeschlosen")

            'Aufgabe ist erledigt, diese aus JobList entfernen
            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'dispatcher wieder aktivieren
            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true

        End  If 'globJobActionID=3



        '*******************************************************************************************************
        '** Bild von Festplatte in PictureBox übertragen
        '*******************************************************************************************************
        '** load picture in PictureBox
        '*******************************************************************************************************
        If globJobActionID=4 then

            Dim myDir As New DirectoryInfo(Application.StartupPath)
            Dim myFiles() As FileInfo 
            Dim DateinameBild As string

            Me.tmrJobWorker.Enabled=false
            globJobActionID=0
                            
            myFiles = myDir.GetFiles("RoboTxtPic_*.jpg")
        
            'Durchzählen der vorhandenen Bilder und das erste fehlerfreie Bild anzeigen
            'count through found pictures and show the first error-free picture
            'myFiles = myDir.GetFiles("RoboTxtPic_*.jpg")
            For n As integer = 0 to myFiles.Length-1
                DateinameBild = myFiles(n).name
                'Debug.Print (DateinameBild)
                'Bild anzeigen
                'show picture
                globErgebnis=ShowRoboPicture(DateinameBild)
                If globErgebnis=True then
                    'Abbruch for-next-Schleife
                    'finish for-next-loop
                    n=myFiles.Length-1
                End if
            Next
        
            'Debug.Print("globJobActionID=4 abgeschlosen")

            'Aufgabe ist erledigt, diese aus JobList entfernen
            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'dispatcher wieder aktivieren
            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true

        End if 'globJobActionID=4



        '*******************************************************************************************************
        '** Bilder vom RoboTXT Controller auf Festplatte übertragen
        '*******************************************************************************************************
        '** get pictures from RoboTXT controller and write it to hard disk
        '*******************************************************************************************************
        If globJobActionID=5 then

            Me.tmrJobWorker.Enabled=false
            'keine Einstellung "globJobActionID=0" weil der JobFinisher verwednet wird
            'no reset of "globJobActionID=0", because JobFinisher will be used
            
            on Error Resume next

            Ergebnis=RoboTXT.TXT.GetPicture(globIntIpAndresseA,globIntIpAndresseB,globIntIpAndresseC,globIntIpAndresseD)
            'debug.Print("lade Bilder von Camera")

            'Debug.Print("globJobActionID=5 abgeschlosen")

            'Aktivierung des JobFinischers um zu prüfen ob Bilddateien übertragen wurden
            'start JobFinischer, to check if there picture files were stored
            Me.tmrJobFinisher.Interval=5000
            globJobErrorWait=0
            Me.tmrJobFinisher.Enabled=true

        End if 'globJobActionID=5



        '*******************************************************************************************************
        '** Bar Code analysieren
        '*******************************************************************************************************
        '** analyse bar code
        '*******************************************************************************************************
        If globJobActionID=7 then

            Me.tmrJobWorker.Enabled=false
            globJobActionID=0
            
            'BarCode des Bildes analysieren
            'analyse bar code from picture
            Me.txtBarCodeResult.Text= ReadBarCode()

            'Debug.Print("globJobActionID=7 abgeschlosen")

            'Aufgabe ist erledigt, diese aus JobList entfernen
            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'dispatcher wieder aktivieren
            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true

        End if 'globJobActionID=7



        '*******************************************************************************************************
        '** prüfen, ob Eingang I1 aktiv, d.h. Palette auf dem Förderband zur Einlagerung
        '*******************************************************************************************************
        '** check if a pallet waits on belt to be stored in
        '*******************************************************************************************************
        If globJobActionID=8 then

            Me.tmrJobWorker.Enabled=false
            Me.tmrWatchDog.Enabled=false

            globJobActionID=0
            
            Ergebnis=RoboTXT.TXT.GetDigitalAll(globIntIpAndresseA,globIntIpAndresseB,globIntIpAndresseC,globIntIpAndresseD)
            
            If Ergebnis>=128 then
                Ergebnis=Ergebnis-128
            End If
            If Ergebnis>=64 then
                Ergebnis=Ergebnis-64
            End If
            If Ergebnis>=32 then
                Ergebnis=Ergebnis-32
            End If
            If Ergebnis>=16 then
                Ergebnis=Ergebnis-16
            End If
            If Ergebnis>=8 then
                Ergebnis=Ergebnis-8
            End If
            If Ergebnis>=4 then
                Ergebnis=Ergebnis-4
            End If
            If Ergebnis>=2 then
                Ergebnis=Ergebnis-2
            End If
            If Ergebnis>=1 then
                Ergebnis=Ergebnis-1
                Me.tmrWatchDog.Enabled=true
            else
                'transportiere Palette zur Kamera Position, lese den Strich Code und registriere die Palette
                'transport pallet to camera position, read bar code and register pallet
                    NewJob_InwardsBelt
                    NewJob_ReadBarCode
                    CurrMoveInPos=NextFreePos()   'suche nächsten freien Lagerort, find out next storage position
                    NewJob_AddInventory
                'Laderoboter übernimmt die Palette
                'roboter takes pallet
                    NewJob_InZ
                    NewJob_InZ
                    NewJob_InZ
                    NewJob_InwardsBeltTime
                    NewJob_LiftY
                    NewJob_OutZ
                    NewJob_OutZ
                    NewJob_OutZ
                    NewJob_OutY
                    NewJob_OutY
                'definieren Laderoboter zum Einlagern
                'define roboter operation way in
                    NewJob_PathIn
                'Aufgabenabschluss
                'finish job
                    NewJob_StoreFinished
            End If

            'Debug.Print("globJobActionID=8 abgeschlosen")

            'Aufgabe ist erledigt, diese aus JobList entfernen
            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'dispatcher wieder aktivieren
            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true

        End If 'globJobActionID=8



        '*******************************************************************************************************
        '** Digitale Ausgänge in RoboTXT setzen, damit Förderband einwärts läuft für max. 10s
        '** oder wenn Eingang 2 sich ändert (bedeutet dass Palette Pos 2 erreicht hat) 
        '*******************************************************************************************************
        '** move pallet on belt inwards to pos 2 (In2) or max. 10s
        '*******************************************************************************************************
        If globJobActionID=9 then
            
            Me.tmrJobWorker.Enabled=false
            globJobActionID=0

            Dim Output as integer       'Ansteuerung der Ausgänge, setting of outputs
            Dim maxTime as integer      'Laufzeit-Begrenzung, max run time
            Dim Input1 as integer       'Abschaltung möglich über Eingang, interrupt 1
            Dim Input2 as integer       'Abschaltung möglich über Eingang, interrupt 2

            Output=0
            Output=Output+1     'Ausgang 1 wird gesetzt, set output 1
            maxTime=10          'Ausgang wird nach spätestens 10s wieder abgeschaltet, max run time 10s
            Input1=2            'Änderung Eingang 2 kann Ausgang wieder abschalten, interrupt In2 active
            Input2=9            'keine weitere Eingangsüberwachung zur Abschaltung aktiv, interrupt not active

            Ergebnis=RoboTXT.TXT.SetDigitalAll(Output,maxTime,Input1,Input2,globIntIpAndresseA,globIntIpAndresseB,globIntIpAndresseC,globIntIpAndresseD) 

            'Debug.Print("globJobActionID=9 abgeschlosen")
            
            'Aufgabe ist erledigt, diese aus JobList entfernen
            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'dispatcher wieder aktivieren
            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true
            
        End if 'globJobActionID=9



        '*******************************************************************************************************
        '** Digitale Ausgänge in RoboTXT setzen, Lager Roboter einwärts fährt um eine x-Position für max. 10s
        '** oder wenn Eingang 3 sich ändert 
        '*******************************************************************************************************
        '** move storage roboter inwards one x-position  (In3) or max. 10s
        '*******************************************************************************************************
        If globJobActionID=10 then
            
            Me.tmrJobWorker.Enabled=false
            globJobActionID=0

            Dim Output as integer       'Ansteuerung der Ausgänge, setting of outputs
            Dim maxTime as integer      'Laufzeit-Begrenzung, max run time
            Dim Input1 as integer       'Abschaltung möglich über Eingang, interrupt 1
            Dim Input2 as integer       'Abschaltung möglich über Eingang, interrupt 2

            Output=0
            Output=Output+8     'Ausgang 4 wird gesetzt, set output 4
            maxTime=10          'Ausgang wird nach spätestens 10s wieder abgeschaltet, max run time 10s
            Input1=3            'Änderung Eingang 3 kann Ausgang wieder abschalten, interrupt In3 active
            Input2=9            'keine weitere Eingangsüberwachung zur Abschaltung aktiv, interrupt not active

            Ergebnis=RoboTXT.TXT.SetDigitalAll(Output,maxTime,Input1,Input2,globIntIpAndresseA,globIntIpAndresseB,globIntIpAndresseC,globIntIpAndresseD) 

            'Debug.Print("globJobActionID=10 abgeschlosen")
            
            'Aufgabe ist erledigt, diese aus JobList entfernen
            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'dispatcher wieder aktivieren
            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true
            
        End if 'globJobActionID=10



        '*******************************************************************************************************
        '** Digitale Ausgänge in RoboTXT setzen, Lager Roboter auswärts fährt um eine x-Position für max. 10s
        '** oder wenn Eingang 3 sich ändert 
        '*******************************************************************************************************
        '** move storage roboter outwards one x-position  (In3) or max. 10s
        '*******************************************************************************************************
        If globJobActionID=11 then
            
            Me.tmrJobWorker.Enabled=false
            globJobActionID=0

            Dim Output as integer       'Ansteuerung der Ausgänge, setting of outputs
            Dim maxTime as integer      'Laufzeit-Begrenzung, max run time
            Dim Input1 as integer       'Abschaltung möglich über Eingang, interrupt 1
            Dim Input2 as integer       'Abschaltung möglich über Eingang, interrupt 2

            Output=0
            Output=Output+4     'Ausgang 3 wird gesetzt, set output 3
            maxTime=10          'Ausgang wird nach spätestens 10s wieder abgeschaltet, max run time 10s
            Input1=3            'Änderung Eingang 3 kann Ausgang wieder abschalten, interrupt In3 active
            Input2=9            'keine weitere Eingangsüberwachung zur Abschaltung aktiv, interrupt not active

            Ergebnis=RoboTXT.TXT.SetDigitalAll(Output,maxTime,Input1,Input2,globIntIpAndresseA,globIntIpAndresseB,globIntIpAndresseC,globIntIpAndresseD) 

            'Debug.Print("globJobActionID=11 abgeschlosen")
            
            'Aufgabe ist erledigt, diese aus JobList entfernen
            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'dispatcher wieder aktivieren
            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true
            
        End if 'globJobActionID=11



        '*******************************************************************************************************
        '** Digitale Ausgänge in RoboTXT setzen, Lager Roboter einwärts fährt um eine y-Position für max. 10s
        '** oder wenn Eingang 4 sich ändert 
        '*******************************************************************************************************
        '** move storage roboter inwards one y-position  (In4) or max. 10s
        '*******************************************************************************************************
        If globJobActionID=12 then
            
            Me.tmrJobWorker.Enabled=false
            globJobActionID=0

            Dim Output as integer       'Ansteuerung der Ausgänge, setting of outputs
            Dim maxTime as integer      'Laufzeit-Begrenzung, max run time
            Dim Input1 as integer       'Abschaltung möglich über Eingang, interrupt 1
            Dim Input2 as integer       'Abschaltung möglich über Eingang, interrupt 2

            Output=0
            Output=Output+16    'Ausgang 5 wird gesetzt, set output 5
            maxTime=10          'Ausgang wird nach spätestens 10s wieder abgeschaltet, max run time 10s
            Input1=4            'Änderung Eingang 4 kann Ausgang wieder abschalten, interrupt In4 active
            Input2=9            'keine weitere Eingangsüberwachung zur Abschaltung aktiv, interrupt not active

            Ergebnis=RoboTXT.TXT.SetDigitalAll(Output,maxTime,Input1,Input2,globIntIpAndresseA,globIntIpAndresseB,globIntIpAndresseC,globIntIpAndresseD) 

            'Debug.Print("globJobActionID=12 abgeschlosen")
            
            'Aufgabe ist erledigt, diese aus JobList entfernen
            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'dispatcher wieder aktivieren
            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true
            
        End if 'globJobActionID=12



        '*******************************************************************************************************
        '** Digitale Ausgänge in RoboTXT setzen, Lager Roboter auswärts fährt um eine y-Position für max. 10s
        '** oder wenn Eingang 4 sich ändert  
        '*******************************************************************************************************
        '** move storage roboter outwards one y-position  (In4) or max. 10s
        '*******************************************************************************************************
        If globJobActionID=13 then
            
            Me.tmrJobWorker.Enabled=false
            globJobActionID=0

            Dim Output as integer       'Ansteuerung der Ausgänge, setting of outputs
            Dim maxTime as integer      'Laufzeit-Begrenzung, max run time
            Dim Input1 as integer       'Abschaltung möglich über Eingang, interrupt 1
            Dim Input2 as integer       'Abschaltung möglich über Eingang, interrupt 2

            Output=0
            Output=Output+32    'Ausgang 6 wird gesetzt, set output 6
            maxTime=10          'Ausgang wird nach spätestens 10s wieder abgeschaltet, max run time 10s
            Input1=4            'Änderung Eingang 3 kann Ausgang wieder abschalten, interrupt In4 active
            Input2=9            'keine weitere Eingangsüberwachung zur Abschaltung aktiv, interrupt not active

            Ergebnis=RoboTXT.TXT.SetDigitalAll(Output,maxTime,Input1,Input2,globIntIpAndresseA,globIntIpAndresseB,globIntIpAndresseC,globIntIpAndresseD) 

            'Debug.Print("globJobActionID=13 abgeschlosen")
            
            'Aufgabe ist erledigt, diese aus JobList entfernen
            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'dispatcher wieder aktivieren
            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true
            
        End if 'globJobActionID=13



        '*******************************************************************************************************
        '** Digitale Ausgänge in RoboTXT setzen, Lager Roboter einwärts fährt um eine z-Position für max. 10s
        '** oder wenn Eingang 5 sich ändert 
        '*******************************************************************************************************
        '** move storage roboter inwards one z-position  (In5) or max. 10s
        '*******************************************************************************************************
        If globJobActionID=14 then
            
            Me.tmrJobWorker.Enabled=false
            globJobActionID=0

            Dim Output as integer       'Ansteuerung der Ausgänge, setting of outputs
            Dim maxTime as integer      'Laufzeit-Begrenzung, max run time
            Dim Input1 as integer       'Abschaltung möglich über Eingang, interrupt 1
            Dim Input2 as integer       'Abschaltung möglich über Eingang, interrupt 2

            Output=0
            Output=Output+128   'Ausgang 7 wird gesetzt, set output 7
            maxTime=10          'Ausgang wird nach spätestens 10s wieder abgeschaltet, max run time 10s
            Input1=5            'Änderung Eingang 3 kann Ausgang wieder abschalten, interrupt In5 active
            Input2=9            'keine weitere Eingangsüberwachung zur Abschaltung aktiv, interrupt not active

            Ergebnis=RoboTXT.TXT.SetDigitalAll(Output,maxTime,Input1,Input2,globIntIpAndresseA,globIntIpAndresseB,globIntIpAndresseC,globIntIpAndresseD) 

            'Debug.Print("globJobActionID=14 abgeschlosen")
            
            'Aufgabe ist erledigt, diese aus JobList entfernen
            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'dispatcher wieder aktivieren
            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true
            
        End if 'globJobActionID=14



        '*******************************************************************************************************
        '** Digitale Ausgänge in RoboTXT setzen, Lager Roboter auswärts fährt um eine z-Position für max. 10s
        '** oder wenn Eingang 5 sich ändert  
        '*******************************************************************************************************
        '** move storage roboter outwards one z-position  (In5) or max. 10s
        '*******************************************************************************************************
        If globJobActionID=15 then
            
            Me.tmrJobWorker.Enabled=false
            globJobActionID=0

            Dim Output as integer       'Ansteuerung der Ausgänge, setting of outputs
            Dim maxTime as integer      'Laufzeit-Begrenzung, max run time
            Dim Input1 as integer       'Abschaltung möglich über Eingang, interrupt 1
            Dim Input2 as integer       'Abschaltung möglich über Eingang, interrupt 2

            Output=0
            Output=Output+64    'Ausgang 8 wird gesetzt, set output 8
            maxTime=10          'Ausgang wird nach spätestens 10s wieder abgeschaltet, max run time 10s
            Input1=5            'Änderung Eingang 3 kann Ausgang wieder abschalten, interrupt In5 active
            Input2=9            'keine weitere Eingangsüberwachung zur Abschaltung aktiv, interrupt not active

            Ergebnis=RoboTXT.TXT.SetDigitalAll(Output,maxTime,Input1,Input2,globIntIpAndresseA,globIntIpAndresseB,globIntIpAndresseC,globIntIpAndresseD) 

            'Debug.Print("globJobActionID=15 abgeschlosen")
            
            'Aufgabe ist erledigt, diese aus JobList entfernen
            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'dispatcher wieder aktivieren
            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true
            
        End if 'globJobActionID=15



        '*******************************************************************************************************
        '** Digitale Ausgänge in RoboTXT setzen, Lager Roboter einwärts y-Position für 1s
        '*******************************************************************************************************
        '** move storage roboter inwards for 1s in y-position
        '*******************************************************************************************************
        If globJobActionID=16 then
            
            Me.tmrJobWorker.Enabled=false
            globJobActionID=0

            Dim Output as integer       'Ansteuerung der Ausgänge, setting of outputs
            Dim maxTime as integer      'Laufzeit-Begrenzung, max run time
            Dim Input1 as integer       'Abschaltung möglich über Eingang, interrupt 1
            Dim Input2 as integer       'Abschaltung möglich über Eingang, interrupt 2

            Output=0
            Output=Output+16    'Ausgang 5 wird gesetzt, set output 5
            maxTime=1           'Ausgang wird nach spätestens 1s wieder abgeschaltet, max run time 1s
            Input1=9            'keine weitere Eingangsüberwachung zur Abschaltung aktiv, interrupt not active
            Input2=9            'keine weitere Eingangsüberwachung zur Abschaltung aktiv, interrupt not active

            Ergebnis=RoboTXT.TXT.SetDigitalAll(Output,maxTime,Input1,Input2,globIntIpAndresseA,globIntIpAndresseB,globIntIpAndresseC,globIntIpAndresseD) 

            'Debug.Print("globJobActionID=16 abgeschlosen")
            
            'Aufgabe ist erledigt, diese aus JobList entfernen
            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'dispatcher wieder aktivieren
            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true
            
        End if 'globJobActionID=16



        '*******************************************************************************************************
        '** Digitale Ausgänge in RoboTXT setzen, damit Förderband einwärts läuft für 2s
        '*******************************************************************************************************
        '** move pallet on belt inwards to storage roboter for 2s
        '*******************************************************************************************************
        If globJobActionID=17 then
            
            Me.tmrJobWorker.Enabled=false
            globJobActionID=0

            Dim Output as integer       'Ansteuerung der Ausgänge, setting of outputs
            Dim maxTime as integer      'Laufzeit-Begrenzung, max run time
            Dim Input1 as integer       'Abschaltung möglich über Eingang, interrupt 1
            Dim Input2 as integer       'Abschaltung möglich über Eingang, interrupt 2

            Output=0
            Output=Output+1     'Ausgang 1 wird gesetzt, set output 1
            maxTime=2           'Ausgang wird nach spätestens 2s wieder abgeschaltet, max run time 2s
            Input1=9            'keine weitere Eingangsüberwachung zur Abschaltung aktiv, interrupt not active
            Input2=9            'keine weitere Eingangsüberwachung zur Abschaltung aktiv, interrupt not active

            Ergebnis=RoboTXT.TXT.SetDigitalAll(Output,maxTime,Input1,Input2,globIntIpAndresseA,globIntIpAndresseB,globIntIpAndresseC,globIntIpAndresseD) 

            'Debug.Print("globJobActionID=17 abgeschlosen")
            
            'Aufgabe ist erledigt, diese aus JobList entfernen
            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'dispatcher wieder aktivieren
            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true
            
        End if 'globJobActionID=17



        '*******************************************************************************************************
        '** Digitale Ausgänge in RoboTXT setzen, damit Förderband auswärts läuft für max. 5s
        '** oder wenn Eingang 1 sich ändert (bedeutet dass Palette Pos 1 erreicht hat) 
        '*******************************************************************************************************
        '** move pallet on belt outwards to pos 1 (In1) or max. 5s
        '*******************************************************************************************************
        If globJobActionID=18 then
            
            Me.tmrJobWorker.Enabled=false
            globJobActionID=0

            Dim Output as integer       'Ansteuerung der Ausgänge, setting of outputs
            Dim maxTime as integer      'Laufzeit-Begrenzung, max run time
            Dim Input1 as integer       'Abschaltung möglich über Eingang, interrupt 1
            Dim Input2 as integer       'Abschaltung möglich über Eingang, interrupt 2

            Output=0
            Output=Output+2     'Ausgang 2 wird gesetzt, set output 2
            maxTime=5           'Ausgang wird nach spätestens 5s wieder abgeschaltet, max run time 5s
            Input1=1            'Änderung Eingang 1 kann Ausgang wieder abschalten, interrupt In1 active
            Input2=9            'keine weitere Eingangsüberwachung zur Abschaltung aktiv, interrupt not active

            Ergebnis=RoboTXT.TXT.SetDigitalAll(Output,maxTime,Input1,Input2,globIntIpAndresseA,globIntIpAndresseB,globIntIpAndresseC,globIntIpAndresseD) 

            'Debug.Print("globJobActionID=18 abgeschlosen")
            
            'Aufgabe ist erledigt, diese aus JobList entfernen
            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'dispatcher wieder aktivieren
            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true
            
        End if 'globJobActionID=18



        '*******************************************************************************************************
        '** neuen Artikel in Warenbestandsliste aufnehmen
        '*******************************************************************************************************
        '** add new article to inventory
        '*******************************************************************************************************
        If globJobActionID=19 then
            
            Me.tmrJobWorker.Enabled=false
            globJobActionID=0

            'neuen Artikel in Warenbestandsliste aufnehmen
            'add new item to list
            Me.dgvInventory.Rows.Add(Me.txtBarCodeResult.Text, StockListItem(Me.txtBarCodeResult.Text),CurrMoveInPos,Now())

            'Debug.Print("globJobActionID=19 abgeschlosen")
            
            'Aufgabe ist erledigt, diese aus JobList entfernen
            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'dispatcher wieder aktivieren
            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true
            
        End if 'globJobActionID=19



        '*******************************************************************************************************
        '** neuer Artikel ist fertig eingelagert, Auftrag abgeschlossen
        '*******************************************************************************************************
        '** new article in warehouse, operation finished
        '*******************************************************************************************************
        If globJobActionID=20 then
            
            Me.tmrJobWorker.Enabled=false
            globJobActionID=0

            'Durchführung abgeschlossen
            'operation is done
            Me.tmrWatchDog.Enabled=True

            'Debug.Print("globJobActionID=20 abgeschlosen")
            
            'Aufgabe ist erledigt, diese aus JobList entfernen
            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'dispatcher wieder aktivieren
            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true
            
        End if 'globJobActionID=20

    End Sub

    Private Sub NewJob_CheckBeltPos1

        'neuer Vorgang: prüfen, ob Palette auf dem Förderband zur Einlagerung bereit steht
        'new job: get digital input status I1 (pallet on conveyor belt position  1)
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,8,"waiting","look for pallet on conveyor belt position  1",500,now)

        'neuer Vorgang: Pause
        'new job: pause
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,1,"waiting","pause",3000,now)
                
        'wartende Systemprozesse abarbeiten
        'process pending events
        System.Windows.Forms.Application.DoEvents()

        'dispatcher wieder aktivieren
        'restart dispatcher
        Me.tmrJobDispatcher.Enabled=true
        
    End Sub

    Private Sub NewJob_ReadBarCode

        'löschen der Bildanzeigefenster und des bar code Leseergebnisses
        'clear picture frames and bar code result
        Me.pbxCameraImageMod.Image=nothing
        Me.pbxCameraImage.Image=nothing
        Me.txtBarCodeResult.Text=""

        'neuer Vorgang: Bild vom RoboTXT anfordern
        'new job: get picture from RoboTXT
        globJobSequenceNo=globJobSequenceNo+1
        globJobErrorRetry=0 'for JobFinisher
        Me.dgvJobList.Rows.Add(globJobSequenceNo,5,"waiting","get picture from RoboTXT",1000,now)

        'neuer Vorgang: neues Bild in picture box anzeigen
        'new job: show new picture
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,4,"waiting","show new picture",5000,now)

        'neuer Vorgang: Bilder löschen von Festplatte
        'new job: delete all RoboTXT pictures on system
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,3,"waiting","delete all RoboTXT pictures on system",3000,now)

        'neuer Vorgang: bar code analysieren
        'new job: analyse bar code
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,7,"waiting","analyse bar code from camera image",3000,now)

        'neuer Vorgang: Pause
        'new job: pause
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,1,"waiting","pause",1000,now)

        'wartende Systemprozesse abarbeiten
        'process pending events
        System.Windows.Forms.Application.DoEvents()

        'dispatcher wieder aktivieren
        'restart dispatcher
        Me.tmrJobDispatcher.Enabled=true
        
    End Sub
        
    private sub NewJob_InwardsBelt

        'neuer Vorgang: M1 beschalten, damit das Förderband die Palette zu Pos 2 fährt unter den Strich Code Leser
        'new job: set digital output status M1
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,9,"waiting","move pallet on belt inwards to bar code reader" ,500,now)

        'neuer Vorgang: Pause
        'new job: pause
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,1,"waiting","pause",3000,now)
                
        'wartende Systemprozesse abarbeiten
        'process pending events
        System.Windows.Forms.Application.DoEvents()

        'dispatcher wieder aktivieren
        'restart dispatcher
        Me.tmrJobDispatcher.Enabled=true
        
    End Sub

    Private Sub NewJob_InX

        'neuer Vorgang: M2 beschalten, damit der Laderoboters eine x-Position einwärts fährt
        'new job: set digital output status M2
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,10,"waiting","move storage roboter inwards one X-position" ,500,now)

        'neuer Vorgang: Pause
        'new job: pause
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,1,"waiting","pause",3000,now)
                
        'wartende Systemprozesse abarbeiten
        'process pending events
        System.Windows.Forms.Application.DoEvents()

        'dispatcher wieder aktivieren
        'restart dispatcher
        Me.tmrJobDispatcher.Enabled=true

    End Sub

    Private Sub NewJob_OutX

        'neuer Vorgang: M2 beschalten, damit der Laderoboters eine x-Position auswärts fährt
        'new job: set digital output status M2
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,11,"waiting","move storage roboter outwards one X-position" ,500,now)

        'neuer Vorgang: Pause
        'new job: pause
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,1,"waiting","pause",3000,now)
                
        'wartende Systemprozesse abarbeiten
        'process pending events
        System.Windows.Forms.Application.DoEvents()

        'dispatcher wieder aktivieren
        'restart dispatcher
        Me.tmrJobDispatcher.Enabled=true

    End Sub

    Private Sub NewJob_InY

        'neuer Vorgang: M3 beschalten, damit der Laderoboters eine y-Position einwärts fährt
        'new job: set digital output status M3
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,12,"waiting","move storage roboter inwards one Y-position" ,500,now)

        'neuer Vorgang: Pause
        'new job: pause
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,1,"waiting","pause",3000,now)
                
        'wartende Systemprozesse abarbeiten
        'process pending events
        System.Windows.Forms.Application.DoEvents()

        'dispatcher wieder aktivieren
        'restart dispatcher
        Me.tmrJobDispatcher.Enabled=true

    End Sub

    Private Sub NewJob_OutY

        'neuer Vorgang: M3 beschalten, damit der Laderoboters eine y-Position auswärts fährt
        'new job: set digital output status M3
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,13,"waiting","move storage roboter outwards one Y-position" ,500,now)

        'neuer Vorgang: Pause
        'new job: pause
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,1,"waiting","pause",3000,now)
                
        'wartende Systemprozesse abarbeiten
        'process pending events
        System.Windows.Forms.Application.DoEvents()

        'dispatcher wieder aktivieren
        'restart dispatcher
        Me.tmrJobDispatcher.Enabled=true

    End Sub

    Private Sub NewJob_InZ

        'neuer Vorgang: M4 beschalten, damit die Gebel des Laderoboters eine z-Position einwärts fährt
        'new job: set digital output status M4
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,14,"waiting","move storage roboter inwards one Z-position" ,500,now)

        'neuer Vorgang: Pause
        'new job: pause
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,1,"waiting","pause",3000,now)
                
        'wartende Systemprozesse abarbeiten
        'process pending events
        System.Windows.Forms.Application.DoEvents()

        'dispatcher wieder aktivieren
        'restart dispatcher
        Me.tmrJobDispatcher.Enabled=true

    End Sub

    Private Sub NewJob_OutZ

        'neuer Vorgang: M4 beschalten, damit die Gebel des Laderoboters eine z-Position auswärts fährt
        'new job: set digital output status M4
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,15,"waiting","move storage roboter outwards one Z-position" ,500,now)

        'neuer Vorgang: Pause
        'new job: pause
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,1,"waiting","pause",3000,now)
                
        'wartende Systemprozesse abarbeiten
        'process pending events
        System.Windows.Forms.Application.DoEvents()

        'dispatcher wieder aktivieren
        'restart dispatcher
        Me.tmrJobDispatcher.Enabled=true

    End Sub

    private Sub NewJob_LiftY

        'neuer Vorgang: M3 beschalten, damit Laderoboter die Gabel etwas anhebt
        'new job: set digital output status M3
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,16,"waiting","move storage roboter inwards and lift Y-position" ,500,now)

        'neuer Vorgang: Pause
        'new job: pause
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,1,"waiting","pause",3000,now)
                
        'wartende Systemprozesse abarbeiten
        'process pending events
        System.Windows.Forms.Application.DoEvents()

        'dispatcher wieder aktivieren
        'restart dispatcher
        Me.tmrJobDispatcher.Enabled=true

    End Sub

    Private Sub NewJob_InwardsBeltTime

        'neuer Vorgang: M1 beschalten, damit Förderband einwärts läuft
        'new job: set digital output status M1
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,17,"waiting","move pallet on belt inwards to storage roboter" ,500,now)

        'neuer Vorgang: Pause
        'new job: pause
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,1,"waiting","pause",3000,now)
                
        'wartende Systemprozesse abarbeiten
        'process pending events
        System.Windows.Forms.Application.DoEvents()

        'dispatcher wieder aktivieren
        'restart dispatcher
        Me.tmrJobDispatcher.Enabled=true

    End Sub

    private Sub NewJob_OutwardsBelt

        'neuer Vorgang: M1 beschalten, damit Förderband auswärts läuft
        'new job: set digital output status M1
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,18,"waiting","move pallet on belt outwards" ,500,now)

        'neuer Vorgang: Pause
        'new job: pause
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,1,"waiting","pause",3000,now)
                
        'wartende Systemprozesse abarbeiten
        'process pending events
        System.Windows.Forms.Application.DoEvents()

        'dispatcher wieder aktivieren
        'restart dispatcher
        Me.tmrJobDispatcher.Enabled=true

    End Sub

    private Sub NewJob_AddInventory

        'neuer Vorgang: neuen Artikel in Warenbestandsliste eintragen
        'new job: add inventory
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,19,"waiting","add new article to inventory" ,500,now)

        'wartende Systemprozesse abarbeiten
        'process pending events
        System.Windows.Forms.Application.DoEvents()

        'dispatcher wieder aktivieren
        'restart dispatcher
        Me.tmrJobDispatcher.Enabled=true

    End Sub

    private sub NewJob_StoreFinished

        'neuer Vorgang: neuer Artikel ist fertig eingelagert, Auftrag abgeschlossen
        'new job: new article in storeage, operation finished
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,20,"waiting","new article in warehouse, operation finished" ,500,now)

        'wartende Systemprozesse abarbeiten
        'process pending events
        System.Windows.Forms.Application.DoEvents()

        'dispatcher wieder aktivieren
        'restart dispatcher
        Me.tmrJobDispatcher.Enabled=true

    End Sub

    Private Sub NewJob_PathIn

        'Einwärtsfahrt x-Richtung
        'path in x-direction
        If Strings.left (CurrMoveInPos,1)="A" then
            NewJob_InX
            NewJob_InX
        End If
        If Strings.left (CurrMoveInPos,1)="B" then
            NewJob_InX
            NewJob_InX
            NewJob_InX
            NewJob_InX
        End If
        If Strings.left (CurrMoveInPos,1)="C" then
            NewJob_InX
            NewJob_InX
            NewJob_InX
            NewJob_InX
            NewJob_InX
            NewJob_InX
        End If

        'Einwärtsfahrt x-Richtung, exakte Positionierung
        'path in precise x-positioning
        NewJob_InX
        NewJob_OutX

        'Einwärtsfahrt y-Richtung
        'path in y-direction
        If Strings.right (CurrMoveInPos,1)="1" then
            'keine Bewegung
            'no operation
        End If
        If Strings.right (CurrMoveInPos,1)="2" then
            NewJob_InY
            NewJob_InY
            NewJob_InY
        End If
        If Strings.right (CurrMoveInPos,1)="3" then
            NewJob_InY
            NewJob_InY
            NewJob_InY
            NewJob_InY
            NewJob_InY
        End If
        If Strings.right (CurrMoveInPos,1)="4" then
            NewJob_InY
            NewJob_InY
            NewJob_InY
            NewJob_InY
            NewJob_InY
            NewJob_InY
            NewJob_InY
        End If

        'Einwärtsfahrt y-Richtung, Laderoboter etwas anheben
        'path in y-direction lift
        NewJob_LiftY

        'Palette in Fach einfahren
        'move pallet in stock location 
        NewJob_InZ
        NewJob_InZ
        NewJob_InZ

        'Palette in Fach ablegen
        'drop pallet in stock location
        NewJob_OutY
        NewJob_OutY

        'Gabel des Laderoboters zurückziehen
        'retract fork of storage roboter from stock location
        NewJob_OutZ
        NewJob_OutZ
        NewJob_OutZ

        'zurück zur Parkposition des Laderoboters
        'move storage roboter to park position

        'Auswärtsfahrt y-Richtung
        'path out y-direction
        If Strings.right (CurrMoveInPos,1)="1" then
            'keine Bewegung
            'no operation
        End If
        If Strings.right (CurrMoveInPos,1)="2" then
            NewJob_OutY
            NewJob_OutY
        End If
        If Strings.right (CurrMoveInPos,1)="3" then
            NewJob_OutY
            NewJob_OutY
            NewJob_OutY
            NewJob_OutY
        End If
        If Strings.right (CurrMoveInPos,1)="4" then
            NewJob_OutY
            NewJob_OutY
            NewJob_OutY
            NewJob_OutY
            NewJob_OutY
            NewJob_OutY
        End If

        'Auswärtsfahrt x-Richtung
        'path out x-direction
        If Strings.left (CurrMoveInPos,1)="A" then
            NewJob_OutX
            NewJob_OutX
        End If
        If Strings.left (CurrMoveInPos,1)="B" then
            NewJob_OutX
            NewJob_OutX
            NewJob_OutX
            NewJob_OutX
        End If
        If Strings.left (CurrMoveInPos,1)="C" then
            NewJob_OutX
            NewJob_OutX
            NewJob_OutX
            NewJob_OutX
            NewJob_OutX
            NewJob_OutX
        End If

        'Gabel in richtige Höhe für Parkposition einstellen
        'set fork in correct elevation for park position
        NewJob_InY
        NewJob_LiftY
        NewJob_OutY

    End Sub

    Private Sub NewJob_PathOut

        'Einwärtsfahrt x-Richtung
        'path in x-direction
        If Strings.left (CurrMoveOutPos,1)="A" then
            NewJob_InX
            NewJob_InX
        End If
        If Strings.left (CurrMoveOutPos,1)="B" then
            NewJob_InX
            NewJob_InX
            NewJob_InX
            NewJob_InX
        End If
        If Strings.left (CurrMoveOutPos,1)="C" then
            NewJob_InX
            NewJob_InX
            NewJob_InX
            NewJob_InX
            NewJob_InX
            NewJob_InX
        End If

        'Einwärtsfahrt x-Richtung, exakte Positionierung
        'path in precise x-positioning
        NewJob_InX
        NewJob_OutX

        'Einwärtsfahrt y-Richtung
        'path in y-direction
        If Strings.right (CurrMoveOutPos,1)="1" then
            'keine Bewegung
            'no operation
        End If
        If Strings.right (CurrMoveOutPos,1)="2" then
            NewJob_InY
            NewJob_InY
            NewJob_InY
        End If
        If Strings.right (CurrMoveOutPos,1)="3" then
            NewJob_InY
            NewJob_InY
            NewJob_InY
            NewJob_InY
            NewJob_InY
        End If
        If Strings.right (CurrMoveOutPos,1)="4" then
            NewJob_InY
            NewJob_InY
            NewJob_InY
            NewJob_InY
            NewJob_InY
            NewJob_InY
            NewJob_InY
        End If

        'Gabel in Fach einfahren
        'move fork in stock location 
        NewJob_InZ
        NewJob_InZ
        NewJob_InZ

        'Palette im Fach anheben
        'lift pallet in stock location
        NewJob_LiftY

        'Gabel zurückziehen
        'retract fork
        NewJob_OutZ
        NewJob_OutZ
        NewJob_OutZ

        'Verfahren des Laderoboters mit der Palette zum Förderband
        'move storage roboter with pallet to conveyor belt

        'Auswärtsfahrt y-Richtung
        'path out y-direction
        If Strings.right (CurrMoveOutPos,1)="1" then
            NewJob_OutY
        End If
        If Strings.right (CurrMoveOutPos,1)="2" then
            NewJob_OutY
            NewJob_OutY
            NewJob_OutY
        End If
        If Strings.right (CurrMoveOutPos,1)="3" then
            NewJob_OutY
            NewJob_OutY
            NewJob_OutY
            NewJob_OutY
            NewJob_OutY
        End If
        If Strings.right (CurrMoveOutPos,1)="4" then
            NewJob_OutY
            NewJob_OutY
            NewJob_OutY
            NewJob_OutY
            NewJob_OutY
            NewJob_OutY
            NewJob_OutY
        End If

        'Auswärtsfahrt x-Richtung
        'path out x-direction
        If Strings.left (CurrMoveOutPos,1)="A" then
            NewJob_OutX
            NewJob_OutX
        End If
        If Strings.left (CurrMoveOutPos,1)="B" then
            NewJob_OutX
            NewJob_OutX
            NewJob_OutX
            NewJob_OutX
        End If
        If Strings.left (CurrMoveOutPos,1)="C" then
            NewJob_OutX
            NewJob_OutX
            NewJob_OutX
            NewJob_OutX
            NewJob_OutX
            NewJob_OutX
        End If

        'Gabel in richtige Höhe für aufsetzen der Palette auf Förderband
        'fork in right height to drop pallet on conveyor belt
        NewJob_InY
        NewJob_LiftY
       
        'Gabel ausfahren
        'extend fork
        NewJob_InZ
        NewJob_InZ
        NewJob_InZ

        'Palette auf Förderband auflegen
        'set pallet on conveyor belt
        NewJob_OutY

        'Gabel zurückziehen
        'retract fork
        NewJob_OutZ
        NewJob_OutZ
        NewJob_OutZ

        'Palette auf Förderband bis Lichtschranke Pos 1 fahren
        'move pallet on conveyor belt to light barrier pos 1
        NewJob_OutwardsBelt
        
    End Sub

End Class
